package StreamSimulator.Buffer;
import java.util.Vector;
import java.util.Enumeration;
/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */
import java.util.HashMap;
import StreamSimulator.Stream.*;
import StreamSimulator.StreamJoin.*;

import java.io.FileWriter;
import java.io.IOException;

public class JoinBuffer implements StreamBuffer {

  public Vector buffer;
  public int bufferSize;
  public int currentSize;
  public boolean do_bufferAlocation = false;
  public int num_streams;
  public boolean use_histogram = false;
  public boolean dropByOthers;


  public JoinBuffer(int size, int num_streams) {
    this.bufferSize = size;
    this.currentSize = 0;
    this.use_histogram = false;
    this.dropByOthers =true;
    this.num_streams = num_streams;
    buffer = new Vector();
  }

  public synchronized boolean insert(BufferTuple tuple)
  {
    if (currentSize<bufferSize)
    {  buffer.add(tuple);
       currentSize++;
       return true;
    }
    else
      return false;
  }

  public synchronized long[] join(BufferTuple tuple, Topology top)
  {
    if (top.seperate_buffer == false)
    {
      if (tuple.stream_ID==0)
      	return join_UnionBufferTest(tuple,1);
      else if (tuple.stream_ID==1)
      	return join_UnionBufferTest(tuple,0);
      else if (tuple.stream_ID==2)
      	return join_UnionBufferTest(tuple,3);
      else if (tuple.stream_ID==3)
      	return join_UnionBufferTest(tuple,2);
      		
      //return join_UnionBuffer(tuple);
    }  
    return join_SeperateBuffer(tuple, top);
  }
  
   public synchronized long[] join_UnionBufferTest(BufferTuple tuple,int dd)
  {
    int size = buffer.size();
    long[] results = new long[StreamJoin.NUM_ATTRIBUTE];
    int[][] count = new int[this.num_streams][StreamJoin.NUM_ATTRIBUTE];
    for (int i = 0; i < this.num_streams; i++)
      for (int j = 0; j < StreamJoin.NUM_ATTRIBUTE; j++)
        count[i][j] = 0;
    for (int i = 0; i < StreamJoin.NUM_ATTRIBUTE; i++)
      results[i] = 1;
    for (int i = 0; i < size; i++) {
      BufferTuple tpl = (BufferTuple) buffer.elementAt(i);
      if (tpl.stream_ID == dd) {
        /*if (Math.abs(tpl.latitude - tuple.latitude) < 100 &&
            Math.abs(tpl.longtitude
                     - tuple.longtitude) < 100) {
          if (Math.abs(tpl.value - tuple.value) < 10)
            results++;
                 }*/
        for (int j = 0; j < StreamJoin.NUM_ATTRIBUTE; j++) {
          if (tpl.value[j] == tuple.value[j])
            count[tpl.stream_ID][j]++;
        }
      }
    }
    
    for (int j = 0; j < StreamJoin.NUM_ATTRIBUTE; j++) {
      for (int i = 0; i < this.num_streams; i++) {
        if (i == dd)
          results[j] = count[i][j];
      }
    }
    return results;
  }



  public synchronized long[] join_UnionBuffer(BufferTuple tuple)
  {
    int size = buffer.size();
    long[] results = new long[StreamJoin.NUM_ATTRIBUTE];
    int[][] count = new int[this.num_streams][StreamJoin.NUM_ATTRIBUTE];
    for (int i = 0; i < this.num_streams; i++)
      for (int j = 0; j < StreamJoin.NUM_ATTRIBUTE; j++)
        count[i][j] = 0;
    for (int i = 0; i < StreamJoin.NUM_ATTRIBUTE; i++)
      results[i] = 1;
    for (int i = 0; i < size; i++) {
      BufferTuple tpl = (BufferTuple) buffer.elementAt(i);
      if (tpl.stream_ID != tuple.stream_ID) {
        /*if (Math.abs(tpl.latitude - tuple.latitude) < 100 &&
            Math.abs(tpl.longtitude
                     - tuple.longtitude) < 100) {
          if (Math.abs(tpl.value - tuple.value) < 10)
            results++;
                 }*/
        for (int j = 0; j < StreamJoin.NUM_ATTRIBUTE; j++) {
          if (tpl.value[j] == tuple.value[j])
            count[tpl.stream_ID][j]++;
        }
      }
    }
    
    for (int j = 0; j < StreamJoin.NUM_ATTRIBUTE; j++) {
      for (int i = 0; i < this.num_streams; i++) {
        if (i != tuple.stream_ID)

          results[j] *= count[i][j];
      }
    }
    return results;
  }

  public synchronized long[] join_SeperateBuffer(BufferTuple tuple,Topology top)
  {
	FileWriter fw = null;
	try {
		fw = new FileWriter("joinOuptut_tmp",true);
	} catch (IOException e) {
		e.printStackTrace();
	}

    long[] results = new long[StreamJoin.NUM_ATTRIBUTE];
    int[][] count = new int[this.num_streams][StreamJoin.NUM_ATTRIBUTE];
    for (int i = 0; i < this.num_streams; i++)
      for (int j = 0; j < StreamJoin.NUM_ATTRIBUTE; j++)
        count[i][j] = 0;
    for (int i = 0; i < StreamJoin.NUM_ATTRIBUTE; i++)
      results[i] = 1;

    for (int i=0;i<top.numBuffer;i++)
    {
      if (i == tuple.stream_ID)
        continue;
      int size = top.buffer[i].currentSize;
      for (int k = 0; k < size; k++)
      {
        if (k>= top.buffer[i].buffer.size())
          break;
        try
        {
          BufferTuple tpl = (BufferTuple) top.buffer[i].buffer.elementAt(k);
          for (int j = 0; j < StreamJoin.NUM_ATTRIBUTE; j++) {
            if (tpl.value[j] == tuple.value[j])
            {

            	try {
            		fw.write(tpl.value[j] + "\r\n");
            	} catch (IOException e) {
            		e.printStackTrace();
            	}
            
              count[i][j]++;
            }
          }
        }catch(Exception e)
        {
          e.printStackTrace();
          break;
        }
      }
    }
    
    for (int j = 0; j < StreamJoin.NUM_ATTRIBUTE; j++)
    {
      for (int i = 0; i < this.num_streams; i++)
      {
        if (i != tuple.stream_ID)
          results[j] *= count[i][j];
      }
    }

/*
	// DEBUG    
    for(int j = 0; j < count.length; j++) {
    	for(int i = 0; i < count[j].length; i++) {
    		System.out.print(count[j][i] + " ");
    	}
    	System.out.println("");
    }
*/

    try {
	    fw.close();
	} catch (IOException e) {
		e.printStackTrace();
	}
    
    return results;
  }



  public synchronized void drop(Topology top)
  {  
    buffer.remove(0);
    currentSize--;
  }

  public synchronized void validateBuffer(long currentTime, int windowSize)
  {
    for (int i=0;i<this.currentSize;i++)
    {
       if (i==buffer.size())
         break;
       BufferTuple tuple = (BufferTuple)buffer.elementAt(i);
       if (Math.abs(currentTime-tuple.timestamp)>=(windowSize*StreamJoin.UNIT))
       {  
       
       
		    if(StreamJoin.AGING_METHODS == StreamJoin.CONSTANT_TOTAL_CREDIT) {
    	
    			double value = ((BufferTuple)buffer.elementAt(i)).credit;
			    buffer.remove(i);
		    	compensate(value/buffer.size());
				currentSize--;

    			
		    } else {
    	
    			buffer.remove(i);
    		   	currentSize--;
    	   
		    }
		    
		              
       }
    }
  }
  
	public void compensate(double value) {

		for(int i = 0; i<buffer.size(); i++) {
			BufferTuple tp = (BufferTuple)buffer.elementAt(i);
			tp.credit += value;
		}

	}  

  public void aging(long t)
  {}

  public void orderBuffer()
  {}

  public double totalCredit()
  {
    return 0.0;
  }

  public void organizeBuffer(int size)
  {

  }

  public synchronized void moveToNextTuple(long timestamp, int windowsize, long unit)
  {
  }

  public synchronized int lookupCredit(BufferTuple tp)
  {
   int i=0;
    while (i<currentSize)
    {
      BufferTuple tuple = (BufferTuple)buffer.elementAt(i);
      if (tp.stream_ID == tuple.stream_ID)
      {
        /*
        boolean found = true;
        for (int j=0;j<BufferTuple.NUM_ATTRIBUTE;j++)
        {
          if (tp.value[j] != tuple.value[j])
          {
            found =false;
          }
        }
        if (found)
        {  tp.credit = tuple.credit;
           return true;
        }*/
        for (int j=0;j<StreamJoin.NUM_ATTRIBUTE;j++)
        {
          if (tp.value[j] == tuple.value[j])
          {  tp.credit = tuple.credit;
             return i;
          }
        }
      }
      i++;
    }
    return -1;
  }


  public void printBuffer()
  {
    int size = buffer.size();
    for (int i=0; i<size; i++)
    {
      BufferTuple tuple = (BufferTuple)buffer.elementAt(i);
      System.out.println(tuple.value[0]+" "+tuple.credit);
    }
  }

  public synchronized BufferTuple getNewArrivalTuple()
  {
    for (int i=currentSize-1;i>=0;i--)
    {
      BufferTuple tuple = (BufferTuple)buffer.elementAt(i);
      if (tuple.stat == BufferTuple.NEW_ARRIVAL)
        return tuple;
    }
    return null;
  }

  public int[] countStreamSize()
  {
    int[] count = new int[this.num_streams];
    for (int i = 0; i < this.num_streams; i++)
      count[i] = 0;
    int size = this.buffer.size();
    for (int i = 0; i < size; i++) {
      BufferTuple tuple = (BufferTuple) buffer.elementAt(i);
      count[tuple.stream_ID]++;
    }
    return count;
  }
}
