package StreamSimulator.Buffer;

/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
import java.io.*;
import StreamSimulator.Stream.*;
import java.util.*;
import StreamSimulator.StreamGenerator.Generator;
import StreamSimulator.StreamJoin.StreamJoin;


public class OptimalBuffer extends JoinBuffer implements StreamBuffer {
  FileReader dataFile;
  BufferedReader bfData;
  public long timeStamp;
  public int windowSize;
  public long windowHead;
  public int genType;
  public long timeUnit;
  private boolean initial;
  private HashMap[][] statistics;

  public OptimalBuffer(int size, int num_streams, String file, int genType) {
    super(size,num_streams);
    try
    {
      this.genType = genType;
      this.dataFile = new FileReader(file);
      this.bfData = new BufferedReader(dataFile);
      this.initial = false;
      //bfDec.readLine();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public synchronized void drop(Topology top)
  {
    //HashMap[] statistics = this.getFutureKnowledge();
    long min =0;
    int selected =0;
    for (int i=0;i<this.buffer.size();i++)
    {
      BufferTuple tuple = (BufferTuple)buffer.elementAt(i);
      long count=0;
      long timeAhead = tuple.timestamp+this.windowSize*this.timeUnit-this.timeStamp;
      //System.out.println(this.timeStamp+" " + this.windowSize+" "+this.timeUnit);
     // System.out.println(timeAhead+" "+this.timeUnit);
      long index = timeAhead/this.timeUnit;
     // System.out.println(index);
      for (int k=0;k<index;k++)
      {
      	for (int j=0;j<StreamJoin.NUM_ATTRIBUTE;j++)
      	{
        	Integer key = new Integer(tuple.value[j]);
	        Object cntObj = statistics[k][j].get(key);
    	    if (cntObj != null)
        	{
         		 Integer cnt = (Integer)cntObj;
		          count += cnt.longValue();
       		 }
      	}
      }
     // System.out.println(count);
      if (i==0)
         min = count;
      if (count<min)
      {
         selected = i;
         min = count;
      }
    }
    //System.out.println(selected);
    this.buffer.remove(selected);
    this.currentSize--;
  }

  public synchronized void moveToNextTuple(long timestamp, int windowsize, long timeunit)
  {
    try
    {
      this.timeStamp = timestamp;
      this.windowSize = windowsize;
      this.timeUnit = timeunit;
      this.windowHead = timestamp+timeunit*windowsize;
      this.getFutureKnowledge();
      //String next = bfData.readLine();
      //System.out.println(next);
    } 
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public synchronized void getFutureKnowledge()
  {
  	if (initial == false)
  	{
		    statistics = new HashMap[windowSize+1][StreamJoin.NUM_ATTRIBUTE];
		    for (int i=0;i<=windowSize;i++)
		   		for (int j=0;j<StreamJoin.NUM_ATTRIBUTE;j++)
		      		statistics[i][j] = new HashMap();
	}
	else
	{
			for (int i=1;i<=windowSize;i++)
  				statistics[i-1]=statistics[i];	
	}
    String nextLine = null;
    try
	{
		      bfData.mark(10000);
		      nextLine = bfData.readLine();
		      while(nextLine!=null)
		      {	        
		        	if (this.genType == Generator.STOCK)
		        	{      	
		        	   //System.out.println("I am here");
		    	    	StringTokenizer tok = new StringTokenizer(nextLine);
			    	    String strobjID = tok.nextToken();
				        int objID = Integer.parseInt(strobjID);
						String ipaddress = tok.nextToken();
				    	int t = Integer.parseInt(ipaddress);
				    	System.out.println("tt:"+t+"timestamp:"+timeStamp+"windowH:"+windowHead);
				    	if (t>= this.timeStamp && t<=this.windowHead)
		          		{		
		          			  int time = (int)(((long)t-timeStamp)/timeUnit);
		          			  System.out.println("time:"+time);
				              Integer data = new Integer(objID);
				              if (statistics[time][0].isEmpty())
				                statistics[time][0].put(data, new Integer(1));
				              else
				              {
				                if (statistics[time][0].containsKey(data))
				                {
				                  Integer val = (Integer) statistics[time][0].get(data);
				                  statistics[time][0].put(data, new Integer(val.intValue() + 1));
				                }
				                else
				                  statistics[time][0].put(data, new Integer(1));
				              }
				        }
				        else
				        	break;
					}
		        	else if (this.genType == Generator.GISMO)
		        	{
		        	
		        	}
		        	else if (this.genType == Generator.WEATHER)
		        	{
		        	
		        	}
			        bfData.mark(10000);
			        nextLine = bfData.readLine();
		      }
		      initial = true;
		      bfData.reset();
		      return;
	}
	catch (Exception e) {
		      e.printStackTrace();
	}
  }
}
