package StreamSimulator.Buffer;

/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

import java.util.Random;
import java.util.GregorianCalendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Vector;
import StreamSimulator.Stream.*;
import StreamSimulator.Buffer.*;

public class RandomSheddingBuffer extends JoinBuffer implements StreamBuffer {

  private Random rand;
  public RandomSheddingBuffer(int size, int num_streams) {
    super(size, num_streams);
    GregorianCalendar calendar = new GregorianCalendar();
    Date date = calendar.getTime();
    this.rand = new Random(date.getTime());
  }

  public synchronized void drop(Topology t)
  {
    int index= this.rand.nextInt(this.currentSize);
    this.buffer.remove(index);
    this.currentSize--;
  }
}
