package StreamSimulator.Clock;

/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */
import java.util.*;
import StreamSimulator.StreamJoin.StreamJoin;
import StreamSimulator.StreamGenerator.Generator;

public class Clock {

    Vector listeners;
    ClockListener finalListener;
    ClockListener initialListener;

    long time = 1;
    long unit = 1;
    //static public long stime=46489;
    static public long stime=1;

    /** Constructor */
    public Clock() {
    	if(StreamJoin.STREAM_TYPE == Generator.GISMO)
			time = 1;
		else if(StreamJoin.STREAM_TYPE == Generator.STOCK)
			time = 25900000;
		else if(StreamJoin.STREAM_TYPE == Generator.WEATHER)
			time = 46490;
        listeners = new Vector();
        finalListener = null;
        initialListener = null;
    }
    
    public Clock(long unit) {
    	if(StreamJoin.STREAM_TYPE == Generator.GISMO)
			time = 1;
		else if(StreamJoin.STREAM_TYPE == Generator.STOCK)
			time = 25900000;
		else if(StreamJoin.STREAM_TYPE == Generator.WEATHER)
			time = 46490;
    	listeners = new Vector();
    	finalListener = null;
    	initialListener = null;
    	this.unit = unit;
    }

    /** Register the specified listener with the clock */
    public void addListener(ClockListener l) {
        listeners.addElement(l);
    }

    /** Allow a specific listener to be guaranteed that it is
        the last to be updated
    */
    public void setFinalListener(ClockListener l) {
        finalListener = l;
    }

    public void setInitialListener(ClockListener l) {
        initialListener =l;
    }

    /** Advance the clock, notifying all of the listeners (in unspecified order),
        with the finalListener notified last.
    */
    public void nextTime() {
        time+=unit;
        /*if (initialListener !=null)
          initialListener.setTime(time);*/
        Enumeration e = listeners.elements();
        while (e.hasMoreElements()) {
            ClockListener l = (ClockListener)e.nextElement();
            l.setTime(time);
        }
        if (finalListener != null)
          finalListener.setTime(time);
    }

    /** Return the current time on the clock */
    public long getTime() {
        return time;
    }

    /** Return the number of epochs represented by the current time.
        Currently, epochs are two time intervals...<p>
    */
    public static int getEpoch(int time) {
        return time >> 1;
    }
}
