package StreamSimulator.Generator;

import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.FileNotFoundException;

import java.util.Arrays;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.StringTokenizer;

import javax.swing.JOptionPane;
import javax.swing.JFrame;

public class Gismo {
	private final int GISMO_ORD = 3;
	private String[][] data;

	public Gismo(JFrame parent, File file) {
		int t = 0;    	
    	String time;
    	GismoTuple obj;
	    StringTokenizer tok;
	    ArrayList arr = new ArrayList();	    
    	BufferedReader in = null;

	    try {
    	    in = new BufferedReader(new FileReader(file));
	    } catch (FileNotFoundException e) { 
   	    	JOptionPane.showMessageDialog(parent,"File not found!",
   	    							"Error: Gismo",JOptionPane.ERROR_MESSAGE);
	    	e.printStackTrace(); 
	    }

		
		String s = new String();
		try {
	    	s = in.readLine();
	    } catch (IOException e) { 
   	    	JOptionPane.showMessageDialog(parent,"Unable to read the input file!",
   	    							"Error: Gismo",JOptionPane.ERROR_MESSAGE);
	    	e.printStackTrace();
	    }
	    
        try {
		    while(s!=null) {
		    	if(s.compareTo("")==0) {
   	      	        s = in.readLine();
		    		continue;
		    	}
				obj = new GismoTuple();
				tok = new StringTokenizer(s, "\t\n\r\f, ");
				obj.user = tok.nextToken();
				obj.time = tok.nextToken();
				obj.object = tok.nextToken();				
				arr.add(obj);
      	        s = in.readLine();
	      	}
   	    } catch (IOException e) {
   	    	JOptionPane.showMessageDialog(parent,"Malformed Gismo data file.",
   	    							"Error: Gismo",JOptionPane.ERROR_MESSAGE);
   	    	e.printStackTrace(); 
   	    }

        data = new String[arr.size()][GISMO_ORD];        
        for(int i = 0; i<arr.size(); i++) {
        	obj = (GismoTuple)arr.get(i);
        	data[i][0] = obj.user;
        	data[i][1] = obj.time;
        	data[i][2] = obj.object;
        }
	}
	
	public String[][] getData() {
		return data;
	}
	
	public void joinData(Gismo gismo) {
		String[][] newdata = new String[data.length + gismo.data.length][GISMO_ORD];
		GismoTuple[] tuples = new GismoTuple[data.length + gismo.data.length];
		for(int i = 0; i<newdata.length; i++) 
			tuples[i] = new GismoTuple();
				
		for(int i = 0; i<data.length; i++) {
        	tuples[i].user   = data[i][0];
        	tuples[i].object = data[i][1];
        	tuples[i].time   = data[i][2];
		}
		
		for(int i = data.length; i<newdata.length; i++) {
			tuples[i].user   = gismo.data[i-data.length][0];
        	tuples[i].object = gismo.data[i-data.length][1];
        	tuples[i].time   = gismo.data[i-data.length][2];		
		}
		
		Arrays.sort(tuples, new GismoComparator());
		
		for(int i = 0; i<newdata.length; i++) {
			newdata[i][0] = tuples[i].user;
			newdata[i][1] = tuples[i].object;
			newdata[i][2] = tuples[i].time;
		}
		
		data = newdata;	
	}
	
	class GismoTuple {
		public String user;
		public String time;
		public String object;
	}
	
	class GismoComparator implements Comparator {
		public int compare(Object o1, Object o2) {
			return Integer.parseInt(((GismoTuple)o1).time) -
					Integer.parseInt(((GismoTuple)o2).time);
		}
	}
}
