package StreamSimulator.Stream;

/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */
import StreamSimulator.Buffer.*;
import StreamSimulator.Clock.*;
import StreamSimulator.StreamGenerator.*;
import StreamSimulator.*;
import java.lang.Math;
import java.util.HashMap;
import java.util.Vector;
import java.lang.String;
import java.util.Random;

public class StreamSource implements ClockListener{

  public Generator gen;
  public int genType;
  public int domainSize;
  public int domainMinVal;
  public double skewness;
  public double sigma;
  public long seed;
  public int arrivalRate;
  public String file;
  public int stream_id;
  public Topology top;
  public boolean finishProducer;
  public Random rand;
  public int sameAttr;
  public TupleProducer tuplePro;
  
  
  public StreamSource(int genType, int domainSize, int domainMinVal,double skewness,
     double sigma1, double sigma2, long seed, int arrivalRate, String file,boolean save_toFile,
     int streamID,int sameAttr, int timeGenType, int totalData, int meanStep,int shift,int range) {
     
    this.genType = genType;
    this.domainSize = domainSize;
    this.domainMinVal = domainMinVal;
    this.skewness = skewness;
    this.sigma = sigma1;
    this.seed = seed;
    this.arrivalRate = arrivalRate;
    this.file=file;
    this.stream_id = streamID;
    this.finishProducer =false;
    this.sameAttr = sameAttr;
    this.gen = new Generator(seed,sameAttr,genType,domainMinVal,domainSize,
      skewness,sigma1, sigma2,stream_id, timeGenType, totalData, meanStep, shift, file, save_toFile, range);
    rand = new Random(seed);
    this.tuplePro = new TupleProducer(this, this.top, -100);
  }


  public void set_topology(Topology t)
  {
    this.top = t;
    this.gen.statistics = t.statistics;
    if (t.bufferAlgo == Topology.PROBABILITY_SHEDDING)
      this.gen.keep_statistics = true;
  }

  public void setTime(long t)
  {
    this.gen.setTime(t);
    this.finishProducer =false;
   	if (this.tuplePro.timestamp == -100)
   	{
   		this.tuplePro.top = this.top;
   	    this.tuplePro.timestamp =t;
  		tuplePro.run();
  	}
	else
	{
    	this.tuplePro.timestamp =t;
	    this.tuplePro.run();
	}
  }
}
