package StreamSimulator.Stream;

/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
import java.util.Random;

import StreamSimulator.Buffer.*;
import StreamSimulator.StreamGenerator.*;
import StreamSimulator.MinSkewPacket.MinSkew2D.*;
import StreamSimulator.MinSkewPacket.MinSkew4D.*;
import StreamSimulator.Clock.Clock;
import StreamSimulator.StreamJoin.StreamJoin;

public class TupleProducer{
  public StreamSource s;
  public Topology top;
  public Random rand = new Random();
  public long timestamp;
  public TupleProducer(StreamSource s, Topology top, long t) {
    this.s = s;
    this.top = top;
    this.timestamp = t;
  }

  public void run()
  {
  
    if (s.genType == Generator.FILEGEN || s.genType == Generator.WC || s.genType == Generator.DAP || 
    	s.genType == Generator.STOCK || s.genType == Generator.GISMO || s.genType == Generator.WEATHER) {
      JoinBuffer buf;
      if (top.seperate_buffer == false)
        buf = top.buffer[0];
      else
        buf = top.buffer[s.stream_id];
      s.arrivalRate =0;
      BufferTuple tuple = s.gen.nextTuple();
      //System.out.println("tupleproducer:"+tuple.timestamp);
      while (tuple != null) 
      {
        s.arrivalRate++;
        if (top.useHistogram == true)
        {
          if (StreamJoin.NUM_ATTRIBUTE ==2 )
          {
            MinSkew2D.updateHistogram(tuple,top.histograms[s.stream_id]);
            Point2D p = new Point2D();
            p.data[0]= tuple.value[0];
            p.data[1]= tuple.value[1];
            top.streamData[s.stream_id].add(p);
          }
          else if (StreamJoin.NUM_ATTRIBUTE ==4)
          {
            MinSkew4D.updateHistogram(tuple,top.histograms[s.stream_id]);
            Point4D p = new Point4D();
            p.data[0]= tuple.value[0];
            p.data[1]= tuple.value[1];
            p.data[2]= tuple.value[2];
            p.data[3]= tuple.value[3];
            top.streamData[s.stream_id].add(p);
          }
        }
        if (this.timestamp<top.warm_up)
        {
          tuple = s.gen.nextTuple();
          continue;
        }
          long[] results = new long[StreamJoin.NUM_ATTRIBUTE];
          results = buf.join(tuple,top);
          for (int i=0;i<StreamJoin.NUM_ATTRIBUTE;i++)
            top.joinResults[s.stream_id][i] += results[i];
          tuple.stat = BufferTuple.OLD_TUPLE;
          buf.orderBuffer();

          
          // sampling
          if(StreamJoin.SAMPLE) {
			int num = rand.nextInt(Integer.MAX_VALUE);
			
			if(num/(double)Integer.MAX_VALUE > StreamJoin.SAMPLE_RATE) {
				if (buf.currentSize < buf.bufferSize)
    	        	buf.insert(tuple);
        	  	else {
            		buf.drop(top);
	            	buf.insert(tuple);
    	        }
			}

          } else {
          
	          if (buf.currentSize < buf.bufferSize)
    	        buf.insert(tuple);
        	  else {
            	buf.drop(top);
	            buf.insert(tuple);
    	      }
    	      
    	  }
          tuple = s.gen.nextTuple();
       }
//       int unit = (int)((this.timestamp-Clock.stime)/StreamJoin.UNIT-1);
  //     top.arrivalRate[unit][s.stream_id] = s.arrivalRate;
    }
    else {
      JoinBuffer buf;
      if (top.seperate_buffer == false)
        buf = top.buffer[0];
      else
      {
        //int sid = (int)Math.abs(1-s.stream_id);
        buf = top.buffer[s.stream_id];
      }
      for (int i = 0; i < s.arrivalRate; i++) 
      {
        BufferTuple tuple = s.gen.nextTuple();
        if (top.useHistogram == true)
        {
          if (StreamJoin.NUM_ATTRIBUTE ==2 )
          {
            if (this.timestamp>top.warm_up)
              MinSkew2D.updateHistogram(tuple,top.histograms[s.stream_id]);
            Point2D p = new Point2D();
            p.data[0]= tuple.value[0];
            p.data[1]= tuple.value[1];
            top.streamData[s.stream_id].add(p);
          }
          else if (StreamJoin.NUM_ATTRIBUTE ==4)
          {
            if (this.timestamp>top.warm_up)
              MinSkew4D.updateHistogram(tuple,top.histograms[s.stream_id]);
            Point4D p = new Point4D();
            p.data[0]= tuple.value[0];
            p.data[1]= tuple.value[1];
            p.data[2]= tuple.value[2];
            p.data[3]= tuple.value[3];
            top.streamData[s.stream_id].add(p);
          }
        }
        if (this.timestamp<top.warm_up)
          continue;
        //System.out.println(s.stream_id+" "+tuple.value[0]+" "+tuple.value[1]);
        long[] results = new long[StreamJoin.NUM_ATTRIBUTE];
        results = buf.join(tuple,top);
        for (int j=0;j<StreamJoin.NUM_ATTRIBUTE;j++)
          top.joinResults[s.stream_id][j] += results[j];
        tuple.stat = BufferTuple.OLD_TUPLE;
        buf.orderBuffer();
        if (buf.currentSize < buf.bufferSize)
          buf.insert(tuple);
        else {
          //System.out.println("I am here "+this.arrivalRate);
          buf.drop(top);
          buf.insert(tuple);
        }
      }
      int unit = (int)((this.timestamp-Clock.stime)/StreamJoin.UNIT-1);
      top.arrivalRate[unit][s.stream_id] = s.arrivalRate;
    }
  }
}
