package StreamSimulator.StreamGenerator;

/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

import StreamSimulator.Buffer.*;
import java.util.*;
import java.lang.*;
import java.io.*;

public class DAPGenerator extends StreamGenerator {

    FileReader decFile;
    BufferedReader bfDec;
    long startTime;
    long lastTime;
    String file;

  public DAPGenerator(String file,long seed) {
    super(seed);

    try
    {
      this.decFile = new FileReader(file);
      this.bfDec = new BufferedReader(decFile);
      this.startTime = 0;
      this.lastTime = 0;
      this.file = file;
      //bfDec.readLine();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public synchronized Vector nextData()
  {
    String nextLine = null;
    try {
          bfDec.mark(200);
          nextLine = bfDec.readLine().trim();
      while (nextLine != null && !nextLine.equals("")) {
        String time = nextLine.substring(0, 8);
        String latitude = nextLine.substring(9,14);
        String longtitude  = nextLine.substring(14,19);
        String stationID = nextLine.substring(19,24);
        String whether = nextLine.substring(25,27);
        String temprature = nextLine.substring(67,71);
        String year = time.substring(0,2);
        String month = time.substring(2,4);
        String day = time.substring(4,6);
        String hour = time.substring(6);

        int intyear = new Integer(year).intValue()+1900;
        int intmonth = new Integer(month).intValue();
        int intday = new Integer(day).intValue();
        int inthour = new Integer(hour).intValue();
        int intlatitude = new Integer(latitude.trim()).intValue();
        int intlongtitude = new Integer(longtitude.trim()).intValue();
        int intstationID = new Integer(stationID.trim()).intValue();
        int intwhether = new Integer(whether.trim()).intValue();
        int inttemprature = new Integer(temprature.trim()).intValue();

        GregorianCalendar date = new GregorianCalendar(intyear,intmonth-1,intday,inthour,0,0);
        long ctime = (long)date.getTime().getTime()/(1000*3600);
        if (this.startTime == 0)
          this.startTime = ctime;
        if (this.lastTime == 0)
          this.lastTime = ctime;
        //System.out.println("DAP GEN:"+intyear+" "+intmonth+" "+intday+" "+inthour+" "+intlatitude+" "+intlongtitude+" "+intstationID+" "+intwhether+" "+inttemprature);
        if (Math.abs(intlatitude-5000)<1000 && Math.abs(intlongtitude-2000)<1000)
        {
          if ((ctime-this.startTime) ==this.timeStamp)
          {
            Vector v = new Vector();
            v.add(new Integer(inttemprature));
            v.add(new Integer(intwhether));
            v.add(new Integer(intstationID));
            v.add(new Integer(intlatitude));
            v.add(new Integer(intlongtitude));
            return v;
          }
          else {
            bfDec.reset();
            this.lastTime = 0;
            return null;
          }
        }
        else
        {
              bfDec.mark(200);
              nextLine = bfDec.readLine().trim();
        }
      }
      return null;
    }
    catch (Exception e) {
      e.printStackTrace();
      return null;
    }
  }


}
