package StreamSimulator.StreamGenerator;

/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

import java.lang.String;
import java.io.*;
import StreamSimulator.Buffer.*;
import java.util.*;
public class DECGenerator extends StreamGenerator {

  FileReader decFile;
  BufferedReader bfDec;

  public DECGenerator(String file, long seed) {
    super(seed);
    try
    {
      this.decFile = new FileReader(file);
      this.bfDec = new BufferedReader(decFile);
      //bfDec.readLine();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public synchronized Vector nextData()
  {
    String nextLine = null;
    try {
      bfDec.mark(100);
      nextLine = bfDec.readLine();
      if (nextLine != null) {
        int index = nextLine.indexOf('.');
        String time = nextLine.substring(0, index);
        Integer integerTime = new Integer(time);
        String ipaddress = nextLine.substring(index + 1);
        Integer integerIp = new Integer(ipaddress);
        int data = integerIp.intValue();
        //System.out.println("DEC GEN:"+integerTime.intValue()+" "+data+" "+this.timeStamp);
        if (integerTime.intValue() == this.timeStamp)
        {
          Vector v = new Vector();
          v.add(new Integer(data));
          return v;
        }
        else {
          bfDec.reset();
          return null;
        }
      }
      else
        return null;
    }
    catch (Exception e)
    {
      e.printStackTrace();
      return null;
    }
  }
}
