package StreamSimulator.StreamGenerator;
import java.util.Vector;
import java.util.Random;
import java.lang.Math;
import StreamSimulator.Buffer.*;
/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class ParetoGenerator extends StreamGenerator{
  private float x1, x2;
  private Random rand;
  private double a;

  public ParetoGenerator(float x1, float x2, double a, long seed) {
    super(seed);
    this.x1 = x1;
    this.x2 = x2;
    this.a = a;
    this.rand = new Random(seed);
  }

  public Vector nextData()
  {
    float u = rand.nextFloat();
    double temp = u*(1.0-Math.pow(x1/x2,a));
    double x = x1/Math.pow((Math.pow(x1,a)-temp),1/a);
    double floatpart = x-Math.floor(x);
    int data=0;
    if (floatpart>=0.5)
      data = (int)Math.ceil(x);
    else
      data = (int)Math.floor(x);
    Vector v = new Vector();
    v.add(new Integer(data));
    return v;
  }
}
