package StreamSimulator.StreamGenerator.TimeCorrelation;

/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
import java.util.*;
import java.lang.Double;

public class RandGaussianTG extends TimeDimensionGenerator{

    private double sigma;
    private Random posRand;
    private HashMap posMap;
    public RandGaussianTG( int genType, int totalData, int domainMinVal,
      int domainSize, long seed, double sigma, double skewness,int meanStep,int shift,int streamID) {
         super(genType,totalData, domainMinVal,domainSize, seed, sigma, skewness,
            meanStep, shift,streamID);
         this.meanStep = meanStep;
         this.sigma = sigma;
         posRand = new Random(seed+43210L);
         posMap = new HashMap();
       }

    public void shiftData()
    {
       Iterator ite = this.statistics.entrySet().iterator();
       while (ite.hasNext())
       {
         Map.Entry entry = (Map.Entry)ite.next();
         Integer key = (Integer)entry.getKey();
         Integer freq = (Integer)entry.getValue();
         genOneGroup(key,freq,shift);
       }
       Comparator2 comparator = new Comparator2();
       Vector entrySet = new Vector(posMap.entrySet());
       Collections.sort(entrySet,comparator);
       Iterator entrySetIte = entrySet.iterator();
       int index=0;
       while (entrySetIte.hasNext())
       {
         Map.Entry entry = (Map.Entry)entrySetIte.next();
         Double key = (Double)entry.getKey();
         //System.out.println(key.doubleValue());
         Integer value = (Integer)entry.getValue();
         this.streamData[index] = value.intValue();
         index++;
       }
    }

    private int genOneGroup(Integer key, Integer value, int shift)
    {
      int count = 0;
      int freq = value.intValue();
      double mean = this.posRand.nextDouble()*((double)totalData);
      while (count < freq) {
        double posVal;
        posVal = this.nextGaussian(mean + shift, sigma);
        Double DposVal = new Double(posVal);
        this.posMap.put(DposVal,key);
        count++;
      }
      return count;
    }

    synchronized private double nextGaussian(double mean, double sigma)
    {
      boolean haveNextNextGaussian = false;
      double nextNextGaussian = 0.0;
      if (haveNextNextGaussian) {
        haveNextNextGaussian = false;
        return nextNextGaussian;
      }
      else {
        double v1, v2, s;
        do {
          v1 = 2 * rand.nextDouble() - 1; // between -1 and 1
          v2 = 2 * rand.nextDouble() - 1; // between -1 and 1
          s = v1 * v1 + v2 * v2;
        }
        while (s >= 1 || s == 0);
        double multiplier = Math.sqrt( -2 * Math.log(s) / s);
        nextNextGaussian = v2 * multiplier * sigma + mean;
        haveNextNextGaussian = true;
        return (v1 * multiplier * sigma + mean);
      }
    }
}
