package StreamSimulator.StreamGenerator.TimeCorrelation;

/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

import java.util.*;
import java.lang.Double;
import java.io.FileWriter;
import java.io.*;

public class RandUniformTG extends TimeDimensionGenerator{

    private Random posRand;
    private Random meanRand;
    private HashMap posMap;
    public int range;
    public HashMap meanHis;
    public RandUniformTG( int genType, int totalData, int domainMinVal,
      int domainSize, long seed, double sigma, double skewness,int meanStep,int shift,
      int range, int streamID)
      {
         super(genType,totalData, domainMinVal,domainSize, seed, sigma, skewness,
            meanStep, shift,streamID);
         posRand = new Random(seed+9876543210L);
         System.out.println(seed+9876543210L);
         meanRand = new Random(seed+123456L);
         posMap = new HashMap();
         meanHis = new HashMap();
         this.range  = range;
       }

    public void shiftData()
    {
          Iterator ite = this.statistics.entrySet().iterator();
          while (ite.hasNext())
          {
            Map.Entry entry = (Map.Entry) ite.next();
            Integer key = (Integer) entry.getKey();
            Integer freq = (Integer) entry.getValue();
            genOneGroup(key, freq, shift, 1);
          }
          Comparator2 comparator = new Comparator2();
          Vector entrySet = new Vector(posMap.entrySet());
          Collections.sort(entrySet, comparator);
          Iterator entrySetIte = entrySet.iterator();
          int index = 0;
          while (entrySetIte.hasNext())
          {
            Map.Entry entry = (Map.Entry) entrySetIte.next();
            Double key = (Double) entry.getKey();
            Integer value = (Integer) entry.getValue();
            //System.out.println(key.doubleValue()+" "+value.intValue());
            this.streamData[index] = value.intValue();
            index++;
            if (index>=this.totalData)
              break;
          }
    }

  public void shiftDataForWindows()
  {
      try
    {
    int[] group = {128};
    for (int i = 0; i < group.length; i++)
    {
      System.out.println("***********************");
      Iterator ite = this.statistics.entrySet().iterator();
      while (ite.hasNext())
      {
        Map.Entry entry = (Map.Entry) ite.next();
        Integer key = (Integer) entry.getKey();
        Integer freq = (Integer) entry.getValue();
        genOneGroup(key, freq, shift, group[i]);
      }
      String file = "data" +this.streamID+group[i];
      //System.out.println(file);
      FileWriter outFile = new FileWriter(file);
      Comparator2 comparator = new Comparator2();
      Vector entrySet = new Vector(posMap.entrySet());
      Collections.sort(entrySet, comparator);
      Iterator entrySetIte = entrySet.iterator();
      int index = 0;
      while (entrySetIte.hasNext())
      {
        Map.Entry entry = (Map.Entry) entrySetIte.next();
        Float key = (Float) entry.getKey();
        Integer value = (Integer) entry.getValue();
        //System.out.println(key.floatValue()+" "+value.intValue());
        this.streamData[index] = value.intValue();
        String output = index + "," + value.intValue() + ","+"\n";
        outFile.write(output);
        index++;
        if (index>=this.totalData)
          break;
      }
      outFile.close();
      System.out.println("done with "+file);
    }
  }catch(Exception e)
  {
    e.printStackTrace();
  }
  }

  public void getMean()
  {
    try
    {
      String file = "mean" + this.streamID;
      BufferedReader inFile = new BufferedReader(new FileReader(file));
      do
      {
        String nextLine = inFile.readLine();
        if (nextLine == null)
          break;
        int index = nextLine.indexOf(',');
        String strKey = nextLine.substring(0, index).trim();
        Integer key = new Integer(strKey);
        int nextIndex= nextLine.indexOf(',', index + 1);
        String strMean = nextLine.substring(index + 1, nextIndex).trim();
        Float mean = new Float(strMean);
        //System.out.println(key.intValue()+":"+mean.floatValue());
        this.meanHis.put(key,mean);
      }while(true);
    }catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public void getData()
  {
    try {
      String file = "stats" + this.streamID;
      BufferedReader inFile = new BufferedReader(new FileReader(file));
      do {
        String nextLine = inFile.readLine();
        if (nextLine == null)
          break;
        int index = nextLine.indexOf(',');
        String strKey = nextLine.substring(0, index).trim();
        Integer key = new Integer(strKey);
        int nextIndex = nextLine.indexOf(',', index + 1);
        String strValue = nextLine.substring(index + 1, nextIndex).trim();
        Integer value = new Integer(strValue);
        this.statistics.put(key, value);
        //System.out.println(key.intValue()+":"+value.intValue());
      }
      while (true);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }


  public void generateMean()
  {
    try
    {
      String file = "mean" + this.streamID;
      //System.out.println(file);
      FileWriter outFile = new FileWriter(file);
      Iterator ite = this.statistics.entrySet().iterator();
      while (ite.hasNext()) {
        Map.Entry entry = (Map.Entry) ite.next();
        Integer key = (Integer) entry.getKey();
        Integer freq = (Integer) entry.getValue();
        float mean = this.meanRand.nextFloat() * ( (float) totalData);
        String output = key.intValue() + "," + mean + "," + "\n";
        outFile.write(output);
      }
      outFile.close();
    }catch(Exception e)
    {
        e.printStackTrace();
    }
  }

    private int genOneGroup(Integer key, Integer value, int shift, int weight)
    {
      int count = 0;
      int freq = value.intValue();
      Object meanObj = this.meanHis.get(key);
      long seed = (long)(posRand.nextDouble()*98765433210.0);
      Random ppRan = new Random(seed);
      Float meanFloat = (Float)meanObj;
      float mean = meanFloat.floatValue();
      while (count < freq) {
        double posVal;
        float tt = ppRan.nextFloat()-(float)0.5;
        posVal = this.totalData+(mean + tt*(float)(weight*range));
        /*while (posVal>this.totalData)
          posVal = posVal-this.totalData;
        while(posVal<0)
          posVal = this.totalData+posVal;*/
        posVal = posVal%this.totalData;
        Float FposVal = new Float(posVal);
        this.posMap.put(FposVal,key);
        count++;
      }
      return count;
    }

}
