package StreamSimulator.StreamGenerator.TimeCorrelation;

/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */
import java.util.Random;
import java.util.*;

import StreamSimulator.Buffer.*;
import StreamSimulator.Stream.*;
import StreamSimulator.StreamGenerator.*;
import StreamSimulator.StreamJoin.StreamJoin;

import java.io.*;

public class TimeDimensionGenerator extends StreamGenerator{
  public static int DEPENDENT = 0;
  public static int INDEPENDENT = 1;
  public int genType;
  public int totalData;
  public int shift;
  public int meanStep;
  public int[] streamData;
  public int currentIndex;
  protected Random rand;
  public long seed;
  public int domainMinVal;
  public int domainSize;
  public StreamGenerator gen;
  public HashMap statistics;
  public int streamID;

  public static int GAUSSIANTG = 1;
  public static int PARETOTG = 2;


  public TimeDimensionGenerator(int genType, int totalData, int domainMinVal,
     int domainSize, long seed, double sigma, double skewness, int meanStep, int shift, int streamID)
  {
    super(seed);
    this.genType = genType;
    this.domainMinVal = domainMinVal;
    this.domainSize = domainSize;
    this.totalData = totalData;
    this.rand = new Random(seed);
    this.streamData = new int[totalData];
    this.currentIndex = 0;
    this.statistics = new HashMap();
    this.shift = shift;
    this.meanStep = meanStep;
    this.streamID = streamID;
    System.out.println(seed);
    for (int i = 0; i < StreamJoin.NUM_ATTRIBUTE; i++)
    {

      if (genType == Generator.UNIFORM)
        gen = new UniformGenerator(this.domainMinVal,
                                          this.domainMinVal +
                                          this.domainSize, seed);
     else if (genType == Generator.GAUSSIAN)
     {
       int max = this.domainMinVal + this.domainSize;
       int mean = (int) Math.ceil( (this.domainMinVal + max) / 2);
       gen = new GaussianGenerator(mean, sigma, seed);
     }
     else if (genType == Generator.PARETO)
       gen = new ParetoGenerator(this.domainMinVal,
                                         this.domainMinVal +
                                         this.domainSize,
                                         skewness, seed);
    }
  }

  public void generateData()
  {
    try
    {
      String file = "data" + this.streamID + 0;
     //System.out.println(file);
      FileWriter outFile = new FileWriter(file);
      for (int i = 0; i < this.totalData; i++)
      {
        Vector v = gen.nextData();
        Integer intData = (Integer) v.elementAt(0);
        this.streamData[i] = intData.intValue();
        String output = i + "," + intData.intValue() + ","+"\n";
        outFile.write(output);
        if (statistics.isEmpty())
          statistics.put(intData, new Integer(1));
        else {
          if (statistics.containsKey(intData)) {
            Integer val = (Integer) statistics.get(intData);
            statistics.put(intData, new Integer(val.intValue() + 1));
          }
          else
            statistics.put(intData, new Integer(1));
        }
      }

      outFile.close();
      file = "stats" + this.streamID;
      outFile = new FileWriter(file);
      Iterator it = statistics.keySet().iterator();
      int cc = 0;
      while (it.hasNext())
      {
        Integer key = (Integer) it.next();
        Integer freq = (Integer) statistics.get(key);
        String output = key.intValue()+","+freq.intValue()+","+"\n";
        //System.out.printt(key.intValue() + "   " + freq.intValue() + "\n");
        //cc += freq.intValue();
        outFile.write(output);
      }
      outFile.close();
    }catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public void shiftData()
  {

  }

  public void shiftDataForWindows()
  {}

  public Vector nextData()
  {
    Vector v = new Vector();
    v.add(new Integer(this.streamData[currentIndex++]));
    return v;
  }
}
