package StreamSimulator.StreamGenerator;
import java.util.Vector;
import java.util.Random;
import java.lang.Math;
import StreamSimulator.Buffer.*;
import java.lang.String;
/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class UniformGenerator extends StreamGenerator{

  private int min, max;
  private Random rand;
  public UniformGenerator(int min, int max, long seed) {
    super(seed);
    this.min = min;
    this.max = max;
    this.rand = new Random(seed);
  }

  public Vector nextData()
  {
    int data;
    float portion = rand.nextFloat();
    float dataTemp = portion*(max-min);
    if ((dataTemp - Math.floor(dataTemp))<0.5)
      data = (int)Math.floor(dataTemp);
    else
      data = (int)Math.ceil(dataTemp);
    Vector v = new Vector();
    v.add(new Integer(data+min));
    return v;
  }
}
