package StreamSimulator.StreamGenerator;

/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

import java.lang.String;
import java.io.*;
import StreamSimulator.Buffer.*;
import java.util.*;

public class WCUPGenerator extends StreamGenerator {
  FileReader wcFile;
  BufferedReader bfWC;

  public WCUPGenerator(String file, long seed) {
    super(seed);
    try
    {
      this.wcFile = new FileReader(file);
      this.bfWC = new BufferedReader(wcFile);
      //bfDec.readLine();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public synchronized Vector nextData()
  {
    String nextLine = null;
    try {
      bfWC.mark(300);
      nextLine = bfWC.readLine();
      if (nextLine != null)
      {
        int index = nextLine.indexOf(',');
        String time = nextLine.substring(0, index);
        Integer integerTime = new Integer(time);
        
        int index1 = nextLine.indexOf(',',index+1);
        String ipaddress = nextLine.substring(index+1,index1);
        Integer integerIp = new Integer(ipaddress);
        int data = integerIp.intValue();
        
        int index2 = nextLine.indexOf(',',index1+1);
        String strobjID = nextLine.substring(index1+1,index2);
        int objID = new Integer(strobjID).intValue();
        
        //System.out.println("WC GEN:"+integerTime.intValue()+" "+data+" "+this.timeStamp+" "+objID+" "+serverID);
        if (integerTime.intValue() == this.timeStamp)
        {
          Vector v = new Vector();
          //System.out.println(data);
          v.add(new Integer(data));
          v.add(new Integer(objID));
          //v.add(new Integer(serverID));
          return v;
        }
        else {
          bfWC.reset();
          return null;
        }
      }
      else
        return null;
    }
    catch (Exception e) {
      e.printStackTrace();
      return null;
    }
  }


}
