package StreamSimulator.StreamGenerator;

import java.lang.String;
import java.io.*;
import StreamSimulator.Buffer.*;
import java.util.*;
import StreamSimulator.StreamJoin.StreamJoin;

public class WeatherDataGenerator extends StreamGenerator {
  FileReader wcFile;
  BufferedReader bfWC;

  public WeatherDataGenerator(String file, long seed) {
    super(seed);
    try
    {
      this.wcFile = new FileReader(file);
      this.bfWC = new BufferedReader(wcFile);
      //bfDec.readLine();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public synchronized Vector nextData()
  {
    String nextLine = null;
    try {
      bfWC.mark(300);
      nextLine = bfWC.readLine();
      if (nextLine != null)
      {
      	StringTokenizer tok = new StringTokenizer(nextLine);
        int t = formatDate(tok.nextToken(), tok.nextToken());
        
        tok.nextToken();
        tok.nextToken();

        double temperature = Double.parseDouble(tok.nextToken());        
        int dewpoint = (int)Double.parseDouble(tok.nextToken());
        int roundtemp = (int)(temperature*1.0);
        
        if (t < this.timeStamp+StreamJoin.UNIT)
        {
          Vector v = new Vector();
          
          //v.add(new Integer(roundtemp));
		  v.add(new Integer(dewpoint));
                              
          return v;
        }
        else {
          bfWC.reset();
          return null;
        }
      }
      else
        return null;
    }
    catch (Exception e) {
      e.printStackTrace();
      return null;
    }
  }
  
  public static int formatDate(String date, String time) {
  	StringTokenizer tok = new StringTokenizer(date, "-");
  	tok.nextToken();
  	int month = Integer.parseInt(tok.nextToken());
  	int day   = Integer.parseInt(tok.nextToken());
  	
  	tok = new StringTokenizer(time, ":");
	int hour = Integer.parseInt(tok.nextToken());	
	int minute = Integer.parseInt(tok.nextToken());
	
	return minute + hour*60 + day*60*24 + month*60*24*31;
  }
}