package StreamSimulator.StreamGenerator;
import java.util.Vector;
import java.util.Random;
import java.util.GregorianCalendar;
import java.util.Date;
import java.lang.Math;
import StreamSimulator.Buffer.*;
/**
 * <p>Title: Li Feifei</p>
 * <p>Description: Stream Simulator for Stream Join Project</p>
 * <p>Copyright: Copyright (c) 2004 Computer Science Department, Boston University</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class ZipfGenerator extends StreamGenerator {

  private float f1, f2;
  private Random rand;
  private double p;

  public ZipfGenerator(float f1, float f2, double p, long seed) {
    super(seed);
    this.f1 = f1;
    this.f2 = f2;
    this.p = p;
    this.rand = new Random(seed);
  }

  /*************************************************************/
/*  zipf generates a random number that follows Zipf         **
**  distribution and lies between f1 and f2.                 **
*/

  public Vector nextData()
  {
    float x;
    float i;
    double r, HsubV, sum;
    int V = 100;

    HsubV = 0.0;
    for (i=1;i<=V;i++)
      HsubV += 1.0/Math.pow((double)i,p);
    r = rand.nextFloat()*HsubV;
    sum = 1.0; i = rand.nextFloat();
    while(sum<r)
    {
      i+=rand.nextFloat()+1.0;
      sum+= 1.0/Math.pow((double)i,p);
    }
    //System.out.println(i);
    x = ((float)i-1)/((float)V-1);
    x = (f2-f1)*x+f1;
    double floatpart = x-Math.floor(x);
    int data=0;
    if (floatpart>=0.5)
      data = (int)Math.ceil(x);
    else
      data = (int)Math.floor(x);
    Vector v = new Vector();
    v.add(new Integer(data));
    return  v;
  }
}
